package $package;

import javax.jws.WebService;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.ow2.weblab.core.model.PieceOfKnowledge;
import org.ow2.weblab.core.services.AccessDeniedException;
import org.ow2.weblab.core.services.Configurable;
import org.ow2.weblab.core.services.ContentNotAvailableException;
import org.ow2.weblab.core.services.InsufficientResourcesException;
import org.ow2.weblab.core.services.InvalidParameterException;
import org.ow2.weblab.core.services.UnexpectedException;
import org.ow2.weblab.core.services.UnsupportedRequestException;
import org.ow2.weblab.core.services.configurable.ConfigureArgs;
import org.ow2.weblab.core.services.configurable.ConfigureReturn;
import org.ow2.weblab.core.services.configurable.ResetConfigurationArgs;
import org.ow2.weblab.core.services.configurable.ResetConfigurationReturn;

/**
 * Template for WebLab service which uses Configurable interface
 * 
 * @author WebLab Team
 */
@WebService(endpointInterface = "org.ow2.weblab.core.services.Configurable")
public class $className implements Configurable {


	/**
	 * The instance of logger used inside $className
	 */
	private final Log logger;


	/**
	 * Constructor
	 */
	public $className() {
		this.logger = LogFactory.getLog(this.getClass());

		// TODO Initialise other fields if needed

		this.logger.info("Service $className successfully started");
	}


	@Override
	public ConfigureReturn configure(final ConfigureArgs args) throws AccessDeniedException, ContentNotAvailableException, InsufficientResourcesException,
			InvalidParameterException, UnexpectedException, UnsupportedRequestException {
		this.logger.debug("Early start of configure method.");

		final PieceOfKnowledge configuration = this.checkConfigureArgs(args);

		this.logger.info("Configure with configuration " + configuration.getUri() + ".");

		// TODO Implement your method here!

		this.logger.error("Method configure not yet implemented.");
		throw new UnsupportedRequestException("Method configure not yet implemented.");
	}


	/**
	 * Method that tests that the ConfigureArgs is correct regarding specification of $className
	 * 
	 * @param args
	 *            The argument received by the configure method
	 * @return The configuration inside <code>args</code>
	 * @throws InvalidParameterException
	 *             If args, usageContext or the configuration it contains is <code>null</code>
	 */
	protected PieceOfKnowledge checkConfigureArgs(ConfigureArgs args) throws InvalidParameterException {
		if (args == null) {
			throw new InvalidParameterException("ConfigureArgs is null.");
		}
		final PieceOfKnowledge configuration = args.getConfiguration();
		if (configuration == null) {
			throw new InvalidParameterException("Configuration in ConfigureArgs is null.");
		}
		if (args.getUsageContext() == null) {
			throw new InvalidParameterException("UsageContext in ConfigureArgs is null.");
		}

		// TODO Maybe implement a better test for your configuration (for
		// instance, is a Annotation required?)

		return configuration;
	}


	@Override
	public ResetConfigurationReturn resetConfiguration(final ResetConfigurationArgs args) throws AccessDeniedException, ContentNotAvailableException,
			InsufficientResourcesException, InvalidParameterException, UnexpectedException, UnsupportedRequestException {
		this.logger.debug("Early start of resetConfiguration method.");

		final String usageContext = this.checkResetConfigurationArgs(args);

		this.logger.info("Reset with usage context " + usageContext + ".");

		// TODO Implement your method here!

		this.logger.error("Method resetConfiguration not yet implemented.");
		throw new UnsupportedRequestException("Method resetConfiguration not yet implemented.", "Constructor not yet implemented.");
	}


	/**
	 * Method that tests that the ResetConfigurationArgs is correct regarding specification of $className
	 * 
	 * @param args
	 *            The argument received by the resetConfiguration method
	 * @return The usageContext inside <code>args</code>
	 * @throws InvalidParameterException
	 *             If args is <code>null</code>
	 */
	protected String checkResetConfigurationArgs(ResetConfigurationArgs args) throws InvalidParameterException {
		if (args == null) {
			throw new InvalidParameterException("ResetConfigurationArgs is null.");
		}
		return args.getUsageContext();
	}

}
