package $package;

import org.junit.Before;
import org.junit.Test;
import org.ow2.weblab.core.services.InvalidParameterException;
import org.ow2.weblab.core.services.configurable.ConfigureArgs;

/**
 * Template for WebLab service test which uses Configurable interface
 * 
 * @author WebLab Team
 */
public class $classNameTest {


	/**
	 * Instance of service which implement a Configurable
	 */
	private $className configurable;


	/**
	 * Initialisation before tests
	 */
	@Before
	public void init() {
		this.configurable = new $className();
	}


	/**
	 * Exception tests
	 */
	@Test(expected = InvalidParameterException.class)
	public void testNullConfigureArgs() throws Exception {
		this.configurable = new $className();
		this.configurable.configure(null);
	}


	/**
	 * Exception tests
	 */
	@Test(expected = InvalidParameterException.class)
	public void testNullResource() throws Exception {
		this.configurable = new $className();
		this.configurable.configure(new ConfigureArgs());
	}


	/**
	 * Exception tests
	 */
	@Test(expected = InvalidParameterException.class)
	public void testNullResetConfigurationArgs() throws Exception {
		this.configurable = new $className();
		this.configurable.resetConfiguration(null);
	}

}